summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2023-03-28 14:24:29 +0100
committerPádraig Brady <P@draigBrady.com>2023-03-28 14:24:29 +0100
commita9bd274616a8d2e99736b498e657cda4e6954f3f (patch)
tree490b4fbe787b29ce2fa18f0c4824b2d976f30580
parenta4525de1ef593cb3873eb88caa7279eb32669bda (diff)
downloadcoreutils-a9bd274616a8d2e99736b498e657cda4e6954f3f.tar.gz
dircolors: diagnose read errors
* NEWS: Mention the fix. * src/dircolors.c: Fail upon read error from getline(). * tests/misc/dircolors.sh: Add a new test. * tests/local.mk: Reference the new test.
-rw-r--r--NEWS4
-rw-r--r--src/dircolors.c5
-rw-r--r--tests/local.mk1
-rwxr-xr-xtests/misc/dircolors.sh28
4 files changed, 36 insertions, 2 deletions
diff --git a/NEWS b/NEWS
index 8f602325c..bade99043 100644
--- a/NEWS
+++ b/NEWS
@@ -10,8 +10,8 @@ GNU coreutils NEWS -*- outline -*-
more restricted systems like android or containers etc.
[bug introduced in coreutils-9.2]
- date --file will now diagnose a failure to read the file.
- Previously it would have silently ignored the failure.
+ date --file and dircolors will now diagnose a failure to read a file.
+ Previously they would have silently ignored the failure.
[This bug was present in "the beginning".]
md5sum --check again correctly prints the status of each file checked.
diff --git a/src/dircolors.c b/src/dircolors.c
index f95524b67..f43a57db5 100644
--- a/src/dircolors.c
+++ b/src/dircolors.c
@@ -298,6 +298,11 @@ dc_parse_stream (FILE *fp, char const *filename)
{
if (getline (&input_line, &input_line_size, fp) <= 0)
{
+ if (ferror (fp))
+ {
+ error (0, errno, _("%s: read error"), quotef (filename));
+ ok = false;
+ }
free (input_line);
break;
}
diff --git a/tests/local.mk b/tests/local.mk
index c958c138c..a0c024905 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -306,6 +306,7 @@ all_tests = \
tests/misc/date-sec.sh \
tests/misc/date-tz.sh \
tests/misc/dircolors.pl \
+ tests/misc/dircolors.sh \
tests/misc/dirname.pl \
tests/misc/env-null.sh \
tests/misc/env-S.pl \
diff --git a/tests/misc/dircolors.sh b/tests/misc/dircolors.sh
new file mode 100755
index 000000000..9e2ae2890
--- /dev/null
+++ b/tests/misc/dircolors.sh
@@ -0,0 +1,28 @@
+#!/bin/sh
+
+# Copyright (C) 2023 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <https://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ dircolors
+
+# Make sure dircolors fails when it can't read input
+# (the current directory in this case)
+if ! cat . >/dev/null; then
+ # can't read() directories
+ returns_ 1 dircolors . || fail=1
+fi
+
+Exit $fail